#include <stdio.h>
#include <stdlib.h>
#include <cv.h>
#include <highgui.h>
#include <math.h>
#include "descriptors.h"

int main (int argc, char *argv[]) {
    
    IplImage *img1, *img2, *imgRg, *imgRb;
    int nColor = 64; // numero de cores para quantizar a imagem
    int i;
    // carega a imagem sem alterar o sistema de cores
    img1 = cvLoadImage(argv[1], CV_LOAD_IMAGE_UNCHANGED);
    
    // vetor para armazenar os descritores
    double *GCH1 = (double *)calloc(nColor, sizeof(double));
    double *GCH2 = (double *)calloc(nColor, sizeof(double));
    double *BIC1 = (double *)calloc(nColor*2, sizeof(double));
    double *BIC2 = (double *)calloc(nColor*2, sizeof(double));
  
    // calcula o descritor da imagem de consulta
    GCH(img1, GCH1, nColor);
    BIC(img1, BIC1, nColor);
    
//     for (i=0; i<nColor; i++) {
// 	printf("%.3f ", GCH1[i]);
//     }
    
    double minDistGCH = DBL_MAX, minDistBIC = DBL_MAX;
    char * filename = (char*)calloc(128, sizeof(char));
    for (i=0; i<60; i++) {	  
	  sprintf(filename,"./imgdb/%.2d.jpg",i);
	  // carrega a imagem do banco de imagens
	  img2 = cvLoadImage(filename, CV_LOAD_IMAGE_UNCHANGED);
	  if (!img2) {
		printf("Erro ao abrir imagem %s\n", filename);
		return -1;
	  }
	  
	  // calcula o descritor da imagem no banco de imagens
	  GCH(img2, GCH2, nColor);
	  BIC(img2, BIC2, nColor);
	  
	  double distGCH = distManhattan(GCH1, GCH2, nColor);
	  double distBIC = distManhattan(BIC1, BIC2, nColor*2);
	  
	  // comparar os descritores
	  if (distGCH < minDistGCH) {
	      minDistGCH = distGCH;
	      imgRg = cvCloneImage(img2);
	  }
	  if (distBIC < minDistBIC) {
	      minDistBIC = distBIC;
	      imgRb = cvCloneImage(img2);
	  }
    }
  
    // abre uma janela para exibir imagem
    cvNamedWindow("Imagem_Consulta", CV_WINDOW_AUTOSIZE);
    cvShowImage("Imagem_Consulta", img1);
    cvNamedWindow("Resultado GCH", CV_WINDOW_AUTOSIZE);
    cvShowImage("Resultado GCH", imgRg);
    cvNamedWindow("Resultado BIC", CV_WINDOW_AUTOSIZE);
    cvShowImage("Resultado BIC", imgRb);
    cvWaitKey(0);
    return 0;
}
